"use strict";

exports.__esModule = true;
exports.unescape = exports.testReferenceToken = exports.testJSONPointer = exports.testArrayLocation = exports.testArrayIndex = exports.testArrayDash = exports.parse = exports.evaluate = exports.escape = exports.composeRealms = exports.compile = exports.XMLTranslator = exports.URIFragmentIdentifier = exports.JSONString = exports.JSONPointerTypeError = exports.JSONPointerParseError = exports.JSONPointerKeyError = exports.JSONPointerIndexError = exports.JSONPointerEvaluateError = exports.JSONPointerError = exports.JSONPointerCompileError = exports.Grammar = exports.EvaluationRealm = exports.CSTTranslator = exports.ASTTranslator = void 0;
var JSONString = _interopRequireWildcard(require("./representation/json-string.cjs"));
exports.JSONString = JSONString;
var URIFragmentIdentifier = _interopRequireWildcard(require("./representation/uri-fragment-identifier.cjs"));
exports.URIFragmentIdentifier = URIFragmentIdentifier;
var _grammar = _interopRequireDefault(require("./grammar.cjs"));
exports.Grammar = _grammar.default;
var _index = _interopRequireDefault(require("./parse/index.cjs"));
exports.parse = _index.default;
var _CSTTranslator = _interopRequireDefault(require("./parse/translators/CSTTranslator.cjs"));
exports.CSTTranslator = _CSTTranslator.default;
var _ASTTranslator = _interopRequireDefault(require("./parse/translators/ASTTranslator.cjs"));
exports.ASTTranslator = _ASTTranslator.default;
var _XMLTranslator = _interopRequireDefault(require("./parse/translators/XMLTranslator.cjs"));
exports.XMLTranslator = _XMLTranslator.default;
var _jsonPointer = _interopRequireDefault(require("./test/json-pointer.cjs"));
exports.testJSONPointer = _jsonPointer.default;
var _referenceToken = _interopRequireDefault(require("./test/reference-token.cjs"));
exports.testReferenceToken = _referenceToken.default;
var _arrayLocation = _interopRequireDefault(require("./test/array-location.cjs"));
exports.testArrayLocation = _arrayLocation.default;
var _arrayIndex = _interopRequireDefault(require("./test/array-index.cjs"));
exports.testArrayIndex = _arrayIndex.default;
var _arrayDash = _interopRequireDefault(require("./test/array-dash.cjs"));
exports.testArrayDash = _arrayDash.default;
var _compile = _interopRequireDefault(require("./compile.cjs"));
exports.compile = _compile.default;
var _escape = _interopRequireDefault(require("./escape.cjs"));
exports.escape = _escape.default;
var _unescape = _interopRequireDefault(require("./unescape.cjs"));
exports.unescape = _unescape.default;
var _index2 = _interopRequireDefault(require("./evaluate/index.cjs"));
exports.evaluate = _index2.default;
var _EvaluationRealm = _interopRequireDefault(require("./evaluate/realms/EvaluationRealm.cjs"));
exports.EvaluationRealm = _EvaluationRealm.default;
var _compose = _interopRequireDefault(require("./evaluate/realms/compose.cjs"));
exports.composeRealms = _compose.default;
var _JSONPointerError = _interopRequireDefault(require("./errors/JSONPointerError.cjs"));
exports.JSONPointerError = _JSONPointerError.default;
var _JSONPointerParseError = _interopRequireDefault(require("./errors/JSONPointerParseError.cjs"));
exports.JSONPointerParseError = _JSONPointerParseError.default;
var _JSONPointerCompileError = _interopRequireDefault(require("./errors/JSONPointerCompileError.cjs"));
exports.JSONPointerCompileError = _JSONPointerCompileError.default;
var _JSONPointerEvaluateError = _interopRequireDefault(require("./errors/JSONPointerEvaluateError.cjs"));
exports.JSONPointerEvaluateError = _JSONPointerEvaluateError.default;
var _JSONPointerTypeError = _interopRequireDefault(require("./errors/JSONPointerTypeError.cjs"));
exports.JSONPointerTypeError = _JSONPointerTypeError.default;
var _JSONPointerKeyError = _interopRequireDefault(require("./errors/JSONPointerKeyError.cjs"));
exports.JSONPointerKeyError = _JSONPointerKeyError.default;
var _JSONPointerIndexError = _interopRequireDefault(require("./errors/JSONPointerIndexError.cjs"));
exports.JSONPointerIndexError = _JSONPointerIndexError.default;
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }